// Taken from http://www.fpga4fun.com/PongGame.html
//   by George Smart, Monday, 1st August 2011.
//
// Modified to suite my monitor and to better suit the Spartan-3E Board.

module VidSync_Gen(clk, VGA_HSYNC, VGA_VSYNC, inDisplayArea, CounterX, CounterY);
input clk;
output VGA_HSYNC, VGA_VSYNC;
output inDisplayArea;
output [9:0] CounterX;
output [8:0] CounterY;

//////////////////////////////////////////////////
reg [9:0] CounterX;
reg [8:0] CounterY;
wire CounterXmaxed = (CounterX==10'h2FF);

always @(posedge clk)
if(CounterXmaxed)
	CounterX <= 0;
else
	CounterX <= CounterX + 1;

always @(posedge clk)
if(CounterXmaxed) CounterY <= CounterY + 1;

reg	vga_HS, vga_VS;
always @(posedge clk)
begin
	vga_HS <= (CounterX[9:4]==6'h28); // change this value to move the display horizontally (WAS 2D)
	vga_VS <= (CounterY==479); // change this value to move the display vertically (WAS 500)
end

reg inDisplayArea;
always @(posedge clk)
if(inDisplayArea==0)
	inDisplayArea <= (CounterXmaxed) && (CounterY<480);
else
	inDisplayArea <= !(CounterX==639);
	
assign VGA_HSYNC = ~vga_HS;
assign VGA_VSYNC = ~vga_VS;

endmodule
